class Canvas2 {

    constructor(PT = null) {

        this._el     = document.getElementById(PT && PT.id ? PT.id : 'viewport');
        this._ctx    = this._el.getContext('2d');
        this._width  = this._el.width;
        this._height = this._el.height;
        this._img    = this._ctx.getImageData(0, 0, this._width, this._height);
        this._time   = PT ? (typeof PT == 'number' ? PT : (PT.time ? PT.time : 0)) : 0;
        this.init();
        this.timeout();
    }

    init() { }
    loop() { }

    // Обновления кадра
    timeout() {

        if (this._time) {
            this.loop();
            setTimeout(function() { this.timeout(); }.bind(this), this._time);
        }
        this.flush();
    }

    // Рисование пикселя на экране
    pset(x, y, k) {

        if (x < this._el.width && y < this._el.height && x >= 0 && y >= 0) {

            let p = 4*(Math.trunc(x) + Math.trunc(y) * this._el.width);
            this._img.data[p    ] =  (k >> 16) & 0xff;
            this._img.data[p + 1] =  (k >>  8) & 0xff;
            this._img.data[p + 2] =  (k      ) & 0xff;
            this._img.data[p + 3] = ((k >> 24) & 0xff) ^ 0xff;
        }
    }

    // Обновление экрана
    flush() { this._ctx.putImageData(this._img, 0, 0); }
}
